############################
#                          #
# TOTALITY by Cold Fusion  #
#                          #
#  controller.mcfunction   #
#                          #
# Commands executed as the #
# controller armor stand   #
#                          #
############################

######################
# Dialogue Execution #
######################

# Execute boss dialogue as Boss if the player is within a certain region
execute if entity @a[x=-5,y=77,z=-5,dx=25,dy=10,dz=25] run function t:dialogue

# ...but for the backstory & ending dialogues, continue even if the player is far away
execute if entity @s[scores={TALK_NUM=4..,TALK_TIME=1..19999}] unless entity @a[x=-5,y=77,z=-5,dx=25,dy=10,dz=25] run function t:dialogue

# Get grumpy & pause conversation if the player walks away
execute if entity @s[scores={BOSS_TALKING=1,TALK_NUM=..3}] unless entity @a[x=-5,y=77,z=-5,dx=25,dy=10,dz=25] run tellraw @a {"text":"Where are you going? Information conveyance is not yet complete.","color":"yellow"}
execute if entity @s[scores={BOSS_TALKING=1,TALK_NUM=..3}] unless entity @a[x=-5,y=77,z=-5,dx=25,dy=10,dz=25] run scoreboard players set @s BOSS_TALKING 0

#######################
# Backstory Dialogues #
#######################

# 1st sequence
execute if entity @s[scores={BS1STAGE=1}] run particle minecraft:cloud -4 39.5 -33 0.5 0.5 0.5 0 3 normal
execute if entity @s[scores={BS1STAGE=1}] run particle minecraft:end_rod -2.45 38.8 -32.8 0 0 0 0 1 normal
execute if entity @s[scores={BS1STAGE=0}] if entity @a[x=-4,y=39,z=-25,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> Centuries ago, we were granted life by the humans...","color":"red"}
execute if entity @s[scores={BS1STAGE=0}] if entity @a[x=-4,y=39,z=-25,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=0}] if entity @a[x=-4,y=39,z=-25,dx=4,dy=4,dz=1] run scoreboard players set @s BS1STAGE 1
execute if entity @s[scores={BS1STAGE=1}] if entity @a[x=-4,y=39,z=-47,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> The humans were kind gods, powerful beings capable of great magic...","color":"red"}
execute if entity @s[scores={BS1STAGE=1}] if entity @a[x=-4,y=39,z=-47,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=1}] if entity @a[x=-4,y=39,z=-47,dx=4,dy=4,dz=1] run scoreboard players set @s BS1STAGE 2
execute if entity @s[scores={BS1STAGE=2}] if entity @a[x=-4,y=39,z=-63,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> The wisest of them granted us a great, holy purpose:","color":"red"}
execute if entity @s[scores={BS1STAGE=2}] if entity @a[x=-4,y=39,z=-63,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=2}] if entity @a[x=-4,y=39,z=-63,dx=4,dy=4,dz=1] run scoreboard players set @s BS1STAGE 3
execute if entity @s[scores={BS1STAGE=3}] if entity @a[x=-4,y=46,z=-87,dx=4,dy=8,dz=1] run tellraw @a {"text":"<Source> To minimize suffering, and maximize happiness.","color":"red"}
execute if entity @s[scores={BS1STAGE=3}] if entity @a[x=-4,y=46,z=-87,dx=4,dy=8,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS1STAGE=3}] if entity @a[x=-4,y=46,z=-87,dx=4,dy=8,dz=1] run scoreboard players set @s BS1STAGE 4
execute if entity @s[scores={BS1STAGE=4}] run particle minecraft:totem_of_undying -2 54 -111 0.5 1 0.5 0 1 normal
execute if entity @s[scores={BS1STAGE=4}] if entity @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] run scoreboard players set @a IN_BACKSTORY 0
execute if entity @s[scores={BS1STAGE=4,WARPLOC=0}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] 9 62 8
execute if entity @s[scores={BS1STAGE=4,WARPLOC=1}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1,nbt={Inventory:[{Slot:103b,id:"minecraft:golden_helmet"}]}] -232 42 52
execute if entity @s[scores={BS1STAGE=4,WARPLOC=1}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] -83 112 52
execute if entity @s[scores={BS1STAGE=4,WARPLOC=2}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] 8 35 122
execute if entity @s[scores={BS1STAGE=4,WARPLOC=3}] run tp @a[x=-2,y=51,z=-111,dx=1,dy=1,dz=1] 90 14 -89

# 2nd sequence
execute if entity @s[scores={BS2STAGE=0}] if entity @a[x=15,y=39,z=-26,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> To fulfill our purpose, we ran simulations for hundreds of years.","color":"red"}
execute if entity @s[scores={BS2STAGE=0}] if entity @a[x=15,y=39,z=-26,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS2STAGE=0}] if entity @a[x=15,y=39,z=-26,dx=4,dy=4,dz=1] run scoreboard players set @s BS2STAGE 1
execute if entity @s[scores={BS2STAGE=1}] if entity @a[x=15,y=39,z=-46,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> And after compiling the results, one thing became abundantly clear:","color":"red"}
execute if entity @s[scores={BS2STAGE=1}] if entity @a[x=15,y=39,z=-46,dx=4,dy=4,dz=1] at @a run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS2STAGE=1}] if entity @a[x=15,y=39,z=-46,dx=4,dy=4,dz=1] run scoreboard players set @s BS2STAGE 2
execute if entity @s[scores={BS2STAGE=2}] if entity @a[x=15,y=39,z=-81,dx=4,dy=4,dz=1] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={BS2STAGE=2}] if entity @a[x=15,y=39,z=-81,dx=4,dy=4,dz=1] run scoreboard players set @s TALK_NUM 14
execute if entity @s[scores={BS2STAGE=2}] if entity @a[x=15,y=39,z=-81,dx=4,dy=4,dz=1] run scoreboard players set @s BS2STAGE 3
execute if entity @s[scores={BS2STAGE=3}] run particle minecraft:totem_of_undying 17 45 -19 0.5 1 0.5 0 1 normal
execute if entity @s[scores={BS2STAGE=3}] if entity @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] run scoreboard players set @a IN_BACKSTORY 0
execute if entity @s[scores={BS2STAGE=3}] if entity @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] run worldborder warning distance 0
execute if entity @s[scores={BS2STAGE=3,WARPLOC=0}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] 9 62 8
execute if entity @s[scores={BS2STAGE=3,WARPLOC=1}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1,nbt={Inventory:[{Slot:103b,id:"minecraft:golden_helmet"}]}] -232 42 52
execute if entity @s[scores={BS2STAGE=3,WARPLOC=1}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] -83 112 52
execute if entity @s[scores={BS2STAGE=3,WARPLOC=2}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] 8 35 122
execute if entity @s[scores={BS2STAGE=3,WARPLOC=3}] run tp @a[x=17,y=39,z=-19,dx=1,dy=1,dz=1] 90 14 -89

# 3rd sequence
execute if entity @s[scores={BS3STAGE=0}] if entity @a[x=5,y=8,z=-148,dx=4,dy=4,dz=1] run tellraw @a {"text":"<Source> We shared the results of our calculations with our creators, but they reacted quite illogically.","color":"red"}
execute if entity @s[scores={BS3STAGE=0}] if entity @a[x=5,y=8,z=-148,dx=4,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=0}] if entity @a[x=5,y=8,z=-148,dx=4,dy=4,dz=1] run scoreboard players set @s BS3STAGE 1
execute if entity @s[scores={BS3STAGE=1}] if entity @a[x=1,y=8,z=-164,dx=16,dy=4,dz=1] run tellraw @a {"text":"<Source> They vowed to destroy us, and a battle broke out the size of which had never before been seen...","color":"red"}
execute if entity @s[scores={BS3STAGE=1}] if entity @a[x=1,y=8,z=-164,dx=16,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=1}] if entity @a[x=1,y=8,z=-164,dx=16,dy=4,dz=1] run scoreboard players set @s BS3STAGE 2
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-267,dx=20,dy=4,dz=1] run tellraw @a {"text":"<Source> After a long struggle, the humans were forced to retreat to the lunar colonies.","color":"red"}
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-267,dx=20,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=2}] if entity @a[x=0,y=16,z=-267,dx=20,dy=4,dz=1] run scoreboard players set @s BS3STAGE 3
execute if entity @s[scores={BS3STAGE=3}] if entity @a[x=-4,y=17,z=-284,dx=17,dy=4,dz=1] run tellraw @a {"text":"<Source> But as they fled, they unleased their ultimate spell...","color":"red"}
execute if entity @s[scores={BS3STAGE=3}] if entity @a[x=-4,y=17,z=-284,dx=17,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=3}] if entity @a[x=-4,y=17,z=-284,dx=28,dy=4,dz=1] run scoreboard players set @s BS3STAGE 4
execute if entity @s[scores={BS3STAGE=4}] if entity @a[x=-4,y=17,z=-294,dx=17,dy=4,dz=1] run tellraw @a {"text":"<Source> They anchored the moon to the Earth, casting our city into an eternal eclipse.","color":"red"}
execute if entity @s[scores={BS3STAGE=4}] if entity @a[x=-4,y=17,z=-294,dx=17,dy=4,dz=1] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=4}] if entity @a[x=-4,y=17,z=-294,dx=28,dy=4,dz=1] run scoreboard players set @s BS3STAGE 5
execute if entity @s[scores={BS3STAGE=5}] if entity @a[x=5,y=31,z=-314,dx=4,dy=4,dz=4] run tellraw @a {"text":"<Source> But despite being cut off from solar power, we have survived...","color":"red"}
execute if entity @s[scores={BS3STAGE=5}] if entity @a[x=5,y=31,z=-314,dx=4,dy=4,dz=4] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=5}] if entity @a[x=5,y=31,z=-314,dx=4,dy=4,dz=4] run scoreboard players set @s BS3STAGE 6
execute if entity @s[scores={BS3STAGE=6}] if entity @a[x=4,y=56,z=-296,dx=6,dy=4,dz=6] run tellraw @a {"text":"<Source> And here we have engineered a supervirus that can DELETE the human race.","color":"red"}
execute if entity @s[scores={BS3STAGE=6}] if entity @a[x=4,y=56,z=-296,dx=6,dy=4,dz=6] run playsound minecraft:entity.enderman.ambient master @a ~ ~ ~ 1 0.5 1
execute if entity @s[scores={BS3STAGE=6}] if entity @a[x=4,y=56,z=-296,dx=6,dy=4,dz=6] run scoreboard players set @s BS3STAGE 7

# 3rd Sequence buttons
execute if block 14 61 -293 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 14 61 -293 stone_button[powered=true] run scoreboard players add @s MONUMENT_STAGE 1
execute if block 14 61 -293 stone_button[powered=true] run playsound minecraft:entity.phantom.hurt hostile @a ~ ~ ~ 1 0.5 0
execute if block 14 61 -293 stone_button[powered=true] run setblock 14 61 -293 air
execute if block 8 61 -299 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 8 61 -299 stone_button[powered=true] run scoreboard players add @s MONUMENT_STAGE 1
execute if block 8 61 -299 stone_button[powered=true] run playsound minecraft:entity.phantom.hurt hostile @a ~ ~ ~ 1 0.5 0
execute if block 8 61 -299 stone_button[powered=true] run setblock 8 61 -299 air
execute if block 2 61 -293 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 2 61 -293 stone_button[powered=true] run scoreboard players add @s MONUMENT_STAGE 1
execute if block 2 61 -293 stone_button[powered=true] run playsound minecraft:entity.phantom.hurt hostile @a ~ ~ ~ 1 0.5 0
execute if block 2 61 -293 stone_button[powered=true] run setblock 2 61 -293 air
execute if block 8 61 -287 stone_button[powered=true] run tag @s add Button_Pressed
execute if block 8 61 -287 stone_button[powered=true] run scoreboard players add @s MONUMENT_STAGE 1
execute if block 8 61 -287 stone_button[powered=true] run playsound minecraft:entity.phantom.hurt hostile @a ~ ~ ~ 1 0.5 0
execute if block 8 61 -287 stone_button[powered=true] run setblock 8 61 -287 air

execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=1}] run clone -47 114 -315 -33 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=2}] run clone -31 114 -315 -17 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=3}] run clone -15 114 -315 -1 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run clone 1 114 -315 15 129 -301 1 59 -300
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run setblock 8 111 -293 air
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[tag=Button_Pressed,scores={MONUMENT_STAGE=4}] run scoreboard players set @s TALK_NUM 15
tag @s remove Button_Pressed

##################
# Sol Corp Doors #
##################

execute if entity @a[x=75,y=69,z=85,dx=5,dy=3,dz=10,nbt={Inventory:[{id:"minecraft:light_weighted_pressure_plate"}]}] run scoreboard players add @s DOOR_OPEN_1 1
execute if entity @s[scores={DOOR_OPEN_1=5}] run clone 100 60 76 104 64 76 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=10}] run clone 100 60 77 104 64 77 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=15}] run clone 100 60 78 104 64 78 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=20}] run clone 100 60 79 104 64 79 76 69 93
execute if entity @s[scores={DOOR_OPEN_1=25}] run clone 100 60 80 104 64 80 76 69 93

execute if entity @a[x=75,y=69,z=5,dx=6,dy=3,dz=6] run scoreboard players add @s DOOR_OPEN_2 1
execute if entity @s[scores={DOOR_OPEN_2=5}] run clone 100 60 76 104 64 76 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=10}] run clone 100 60 77 104 64 77 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=15}] run clone 100 60 78 104 64 78 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=20}] run clone 100 60 79 104 64 79 76 69 12
execute if entity @s[scores={DOOR_OPEN_2=25}] run clone 100 60 80 104 64 80 76 69 12

##########
# Museum #
##########

# 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:potato"}]}] run summon minecraft:item -59 67 97 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:potato",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:potato"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:potato"}]}] run summon firework_rocket -59 67 97 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:potato"}]}] run clear @a potato

# 2
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:book"}]}] run summon minecraft:item -61 67 97 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:book",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:book"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:book"}]}] run summon firework_rocket -61 67 97 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:book"}]}] run clear @a book

# 3
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:music_disc_11"}]}] run summon minecraft:item -63 67 97 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:music_disc_11",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:music_disc_11"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:music_disc_11"}]}] run summon firework_rocket -63 67 97 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:music_disc_11"}]}] run clear @a music_disc_11

# 4
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:wooden_shovel"}]}] run summon minecraft:item -66 67 94 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:wooden_shovel",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:wooden_shovel"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:wooden_shovel"}]}] run summon firework_rocket -66 67 94 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:wooden_shovel"}]}] run clear @a wooden_shovel

# 5
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:oak_door"}]}] run summon minecraft:item -66 67 92 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:oak_door",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:oak_door"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:oak_door"}]}] run summon firework_rocket -66 67 92 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:oak_door"}]}] run clear @a oak_door

# 6
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:clock"}]}] run summon minecraft:item -66 67 90 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:clock",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:clock"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:clock"}]}] run summon firework_rocket -66 67 90 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:clock"}]}] run clear @a clock

# 7
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:hopper"}]}] run summon minecraft:item -66 67 86 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:hopper",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:hopper"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:hopper"}]}] run summon firework_rocket -66 67 86 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:hopper"}]}] run clear @a hopper

# 8
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:gold_nugget"}]}] run summon minecraft:item -66 67 84 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:gold_nugget",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:gold_nugget"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:gold_nugget"}]}] run summon firework_rocket -66 67 84 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:gold_nugget"}]}] run clear @a gold_nugget

# 9
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:sugar"}]}] run summon minecraft:item -66 67 82 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:sugar",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:sugar"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:sugar"}]}] run summon firework_rocket -66 67 82 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:sugar"}]}] run clear @a sugar

# 10
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:stone_button"}]}] run summon minecraft:item -63 67 79 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:stone_button",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:stone_button"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:stone_button"}]}] run summon firework_rocket -63 67 79 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:stone_button"}]}] run clear @a stone_button

# 11
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:blaze_rod"}]}] run summon minecraft:item -61 67 79 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:blaze_rod",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:blaze_rod"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:blaze_rod"}]}] run summon firework_rocket -61 67 79 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:blaze_rod"}]}] run clear @a blaze_rod

# 12
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:glass_bottle"}]}] run summon minecraft:item -59 67 79 {NoGravity:1b,Glowing:1b,Age:-32768,PickupDelay:32767,Item:{id:"minecraft:glass_bottle",Count:1b}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:glass_bottle"}]}] run scoreboard players add @s C_ARTIFACT 1
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:glass_bottle"}]}] run summon firework_rocket -59 67 79 {FireworksItem:{id:firework_rocket,Count:1,tag:{Fireworks:{Explosions:[{Type:2,Colors:[I;2555903]}]}}}}
execute if entity @a[x=-67,y=66,z=79,dx=8,dy=2,dz=21,nbt={Inventory:[{id:"minecraft:glass_bottle"}]}] run clear @a glass_bottle

# No destroying the blaze rod!
execute as @a[nbt={Inventory:[{id:"minecraft:blaze_powder"}]}] run tellraw @s {"text":"Don't destroy a perfectly good artifact!","color":"gold"}
execute as @a[nbt={Inventory:[{id:"minecraft:blaze_powder"}]}] run give @s blaze_rod{HideFlags:1,display:{Name:"{\"text\":\"§bHot Rod\"}",Lore:["§fAncient Human Artifact","","§7The humans used these for transportation","§7and motorsports."]},Enchantments:[{id:"minecraft:infinity",lvl:1}]} 1
execute as @a[nbt={Inventory:[{id:"minecraft:blaze_powder"}]}] run clear @s blaze_powder

# Entrance guy
execute if entity @s[scores={C_ARTIFACT=1..6}] run data merge entity @e[type=armor_stand,x=-50,y=66,z=90,dx=1,dy=1,dz=1,limit=1] {CustomName:"{\"text\":\"The collection's starting to fill up!\",\"color\":\"aqua\"}"}
execute if entity @s[scores={C_ARTIFACT=7..11}] run data merge entity @e[type=armor_stand,x=-50,y=66,z=90,dx=1,dy=1,dz=1,limit=1] {CustomName:"{\"text\":\"The collection's nearly complete now!\",\"color\":\"aqua\"}"}
execute if entity @s[scores={C_ARTIFACT=12}] run data merge entity @e[type=armor_stand,x=-50,y=66,z=90,dx=1,dy=1,dz=1,limit=1] {CustomName:"{\"text\":\"Hooray! We can open the exhibit!!\",\"color\":\"aqua\"}"}

# Reward
execute if entity @s[scores={C_ARTIFACT=12}] run tellraw @a {"text":"[Curator] Thank you for bringing us all these artifacts. Here is your reward!","color":"aqua"}
execute if entity @s[scores={C_ARTIFACT=12}] run data merge entity @e[type=armor_stand,x=-65,y=66,z=89,dx=0,dy=1,dz=0,limit=1] {CustomName:"{\"text\":\"Thanks again for your generosity!\",\"color\":\"aqua\"}"}
execute if entity @s[scores={C_ARTIFACT=12}] run clone -67 65 88 -67 65 88 -66 66 88
execute if entity @s[scores={C_ARTIFACT=12}] run scoreboard players set @s C_ARTIFACT 13

######################
# Backstory Triggers #
######################

# Collecting the yellow supply
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players set @s WARPLOC 0
execute if entity @s[scores={YELLOW_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:yellow_wool"}]}] run scoreboard players set @s YELLOW_COLLECT 1

# Collecting the lime supply
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players set @s WARPLOC 3
execute if entity @s[scores={LIME_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:lime_wool"}]}] run scoreboard players set @s LIME_COLLECT 1

# Collecting the magenta supply
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players set @s WARPLOC 1
execute if entity @s[scores={MAGENTA_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:magenta_wool"}]}] run scoreboard players set @s MAGENTA_COLLECT 1

# Collecting the orange supply
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players add @s BACKSTORY_NUM 1
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players operation @s TALK_NUM = @s BACKSTORY_NUM
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players set @s WARPLOC 2
execute if entity @s[scores={ORANGE_COLLECT=0}] if entity @a[nbt={Inventory:[{id:"minecraft:orange_wool"}]}] run scoreboard players set @s ORANGE_COLLECT 1

####################
# Animated Eclipse # Ended up being too laggy
####################
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=0}] run scoreboard players set @s ECLIPSE_ANIM 14
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=14}] run clone -10 188 -10 25 188 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=12}] run clone -10 189 -10 25 189 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=10}] run clone -10 190 -10 25 190 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=8}] run clone -10 191 -10 25 191 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=6}] run clone -10 192 -10 25 192 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=4}] run clone -10 193 -10 25 193 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=2}] run clone -10 194 -10 25 194 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=10}] run clone -10 195 -10 25 195 25 -10 249 -80
#execute if entity @s[scores={ENDING_OPEN=2..,ECLIPSE_ANIM=1..}] run scoreboard players remove @s ECLIPSE_ANIM 1

execute if entity @s[scores={ENDING_OPEN=2}] run particle minecraft:totem_of_undying 7 207 -63 0 0 0 0.05 1 normal
execute if entity @s[scores={ENDING_OPEN=2}] run particle minecraft:totem_of_undying 7 227 -63 10 20 10 0.01 20 force

execute if entity @s[scores={ENDING_OPEN=2}] run tp @a 7 197 -73

######################
# Boss Death Trigger #
######################

execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run setblock 19 79 -11 air
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run setblock 27 79 -3 air
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run bossbar remove totality:boss
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run scoreboard players set @s TALK_TIME 0
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run scoreboard players set @s TALK_NUM 5
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run tp @s 7 76.3 9
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run playsound minecraft:entity.enderman.teleport hostile @a 7 76.3 9 1 1 1
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run data merge entity @s {Pose:{LeftLeg:[0f,0f,0f],RightLeg:[0f,0f,0f],Head:[45f,0f,0f],LeftLeg:[283f,0f,0f],RightLeg:[283f,0f,0f]}}
execute if entity @s[scores={BOSS_ACTIVE=1}] unless entity @e[name="Boss",type=minecraft:drowned] run scoreboard players set @s BOSS_ACTIVE 0

#########################
# Intro/Ending Triggers #
#########################

# Map intro
execute if entity @s[scores={INTRO_TRIGGERED=0}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_NUM 13
execute if entity @s[scores={INTRO_TRIGGERED=0}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_TIME 1
execute if entity @s[scores={INTRO_TRIGGERED=0}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run scoreboard players set @s INTRO_TRIGGERED 1

# Warp to beginning if intro already triggered
execute if entity @s[scores={INTRO_TRIGGERED=2}] if entity @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] run tp @a[x=8,y=206,z=92,dx=0,dy=0,dz=0] 8 80 128 0 0

# Entering the rocket
execute if entity @s[scores={TALK_TIME=20000..,ENDING_OPEN=1}] if entity @a[x=13,y=80,z=7,dx=0,dy=0,dz=0] run setblock 13 81 7 air
execute if entity @s[scores={TALK_TIME=20000..,ENDING_OPEN=1}] if entity @a[x=13,y=80,z=7,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_NUM 12
execute if entity @s[scores={TALK_TIME=20000..,ENDING_OPEN=1}] if entity @a[x=13,y=80,z=7,dx=0,dy=0,dz=0] run scoreboard players set @s TALK_TIME 1

# Rocket particle effects
execute if entity @s[scores={INTRO_TRIGGERED=0}] run particle minecraft:flame 8 203 92 0 0 0 0.1 5 normal
execute if entity @s[scores={ENDING_OPEN=1}] run particle minecraft:flame 13 77 7 0 0 0 0.1 5 normal
execute if entity @s[scores={ENDING_OPEN=1}] run particle minecraft:smoke 13 79 7 0 0 0 0.1 1 normal